#include "util.h"

extern int parse_ull(char * * st, ull * res) {
  ull r, t, c;
  char * p;
  p = *st;
  r = 0;
  if(p[0]=='0') {
    if(p[1]>='0' && p[1]<='9') return -1;
    *st = p+1;
    *res = 0;
    return 0;
  }
  while(1) {
    c = (unsigned char)*p;
    if(c<'0' || c>'9') break;
    c -= '0';
    t = r*10;
    if(t/10!=r) return -1;
    r = t+c;
    if(r<t) return -1;
    p++;
  }
  if(!r) return -1;
  *st = p;
  *res = r;
  return 0;
}

