#ifndef _ONE_WIN_APP_H_
#define _ONE_WIN_APP_H_

/* functions that defined in one_win_app.c */
extern goui_syswin * syswin;
extern goui_uxy sw_size;
extern goui_font * get_debugfont(void);
extern goui_font * get_debugfont_small(void);
extern void debuglog(char const * fmt, ...);
extern void ErrorBox(char const * fmt, ...);
extern void FatalError(char const * fmt, ...);


/* functions that needed from app */
extern void app_pre_init(void);
extern void app_init(void);
extern void app_post_shutdown(void);
extern void app_handle_event(goui_event * ev);
extern int  app_idle_func(unsigned long count);
extern void app_parse_args(int argc, char * * argv);




typedef int (* client_idle_func)(unsigned long);

extern void InvalidateSysRectAndWait(goui_ssize x1, goui_ssize y1, goui_ssize x2, goui_ssize y2);
extern void InvalidateSysRectAndUpdate(goui_ssize x1, goui_ssize y1, goui_ssize x2, goui_ssize y2);
extern void SysWinSetTitle(char const * title);

#endif
