
typedef struct {
  ull ticks_total;      /* total elapsed ticks */
  ull ticks_user;       /* ticks in non-nice user mode */
  ull ticks_nice;       /* ticks in nice user mode */
  ull ticks_system;     /* ticks in kernel mode */
  ull ticks_idle;       /* ticks in idle mode */
  ull ticks_iowait;     /* ticks waiting for i/o (wtf?) */
  ull ticks_irq;        /* ticks handling hardware interrupts */
  ull ticks_softirq;    /* ticks handling softirqs */
  ull ticks_steal;      /* ticks stolen by vm hypervisor and/or other software that are unreachable to our kernel */
  ull ticks_guest;      /* ticks in guest vm */
  ull ticks_guest_nice; /* ticks in niced guest vm */
  ull procs_runnable;   /* num of processes that can run immediately */
  ull procs_waiting_io; /* num of processes that waiting for i/o */
} cpustat;

extern int get_cpustat(cpustat * r);
